#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Export Scene Image
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Misc Tool>Export Scene Image
#		 Note:	
#			
#    Date:	Nov 2016
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
# ------------------------------------------------------ #
unless file_loaded?(__FILE__)
	$sdm_Misc_tools.add_item("Export Scene Image") { SDM::Export_Scene_Image.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Export_Scene_Image
		extend self
		def main
			@mod = Sketchup.active_model
			@vue = @mod.active_view
			@f_typ ||= "png"; @img_wid ||= 640; @img_hgt ||= 480
			vars = UI.inputbox(["Image Type:","Image Width:","Image Height:"],[@f_typ,@img_wid,@img_hgt],["jpg|png"],"Image Specs")
			if vars
				@f_typ,@img_wid,@img_hgt = vars
				@old_path ||= @mod.path ? File.dirname(@mod.path) : Dir.pwd
				full_path = UI.openpanel(@old_path)
				if full_path
					@old_path = full_path.gsub!("\\","/")
					dir_path = File.dirname(full_path)+'/';
					names=Dir.entries(dir_path).select{|n|File.extname(n)=='.skp'}
					path = UI.savepanel("Image Folder",@old_path,"Image.#{@f_typ}")
					if path; 
						@old_path = @Image_Path = File.dirname(path).gsub('\\','/')
						@mod.start_operation "Export Scenes"
						names.each{|n|
							Sketchup.open_file(dir_path+n)
							@Scenes=Sketchup.active_model.pages.map{|p|p.name};
							@mod.options["PageOptions"]["ShowTransition"]=false
							for scene in @Scenes
								@mod.pages.selected_page = @mod.pages[scene];
								puts @Image_Path+"/#{scene}.#{@f_typ}"
								@vue.write_image @Image_Path+"/#{scene}.#{@f_typ}",@img_wid,@img_hgt
							end
							@mod.commit_operation
						}
					end
				end
			end
		end
		
	end
	
end
